<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Document</title>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.7.0/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <style>
        .row {
            align-items: center;
        }
    </style>
</head>

<body>
    <div class="container" style="width: 60%;">
        <h1>Chi tiết user</h1>
        <div class="row">
            <div class="col col-sm-4 col-md-4 col-lg-4 col-xl-4">
                <label for="firstname">First Name</label>
            </div>
            <div class="col col-sm-8 col-md-8 col-lg-8 col-xl-8">
                <input style="width: 100%;background: gainsboro;border: none;height: 40px; margin-top: 10px;"
                    id="firstname" placeholder="Nhập Firstname" />
            </div>
        </div>
        <div class="row">
            <div class="col col-sm-4 col-md-4 col-lg-4 col-xl-4">
                <label for="lastname">Last Name</label>
            </div>
            <div class="col col-sm-8 col-md-8 col-lg-8 col-xl-8">
                <input style="width: 100%;background: gainsboro;border: none;height: 40px; margin-top: 10px;"
                    id="lastname" placeholder="Nhập Lastname" />
            </div>
        </div>
        <div class="row">
            <div class="col col-sm-4 col-md-4 col-lg-4 col-xl-4">
                <label for="subject">Subject</label>
            </div>
            <div class="col col-sm-8 col-md-8 col-lg-8 col-xl-8">
                <input style="width: 100%;background: gainsboro;border: none;height: 40px; margin-top: 10px;"
                    id="subject" placeholder="Nhập Subject" />
            </div>
        </div>
        <div class="row">
            <div class="col col-sm-4 col-md-4 col-lg-4 col-xl-4">
                <label for="country">Country</label>
            </div>
            <div class="col col-sm-8 col-md-8 col-lg-8 col-xl-8">
                <select style="width: 100%;background: gainsboro;border: none;height: 40px; margin-top: 10px;"
                    id="country" placeholder="Nhập Subject">
                    <option value="VN">Việt Nam</option>
                    <option value="USA">USA</option>
                    <option value="AUS">Australia</option>
                    <option value="CAN">Canada</option>
                </select>
            </div>
        </div>
        <div class="row">
            <div class="col col-sm-4 col-md-4 col-lg-4 col-xl-4">
                <label for="customerType">Customer Type</label>
            </div>
            <div class="col col-sm-8 col-md-8 col-lg-8 col-xl-8">
                <select style="width: 100%;background: gainsboro;border: none;height: 40px; margin-top: 10px;"
                    id="customerType">
                    <option value="Standard">Standard</option>
                    <option value="Gold">Gold</option>
                    <option value="Premium">Premium</option>
                </select>
            </div>
        </div>
        <div class="row">
            <div class="col col-sm-4 col-md-4 col-lg-4 col-xl-4">
                <label for="registerStatus">Register Status</label>
            </div>
            <div class="col col-sm-8 col-md-8 col-lg-8 col-xl-8">
                <select style="width: 100%;background: gainsboro;border: none;height: 40px; margin-top: 10px;"
                    id="registerStatus">
                    <option value="New">New</option>
                    <option value="Accepted">Accepted</option>
                    <option value="Deny">Deny</option>
                </select>
            </div>
        </div>
        <div class="row" style="justify-content: center;">
            <button style="margin-right: 10px;margin-top: 20px;" id="updateUser" class="btn btn-success">
                Update user
            </button>
            <button style="margin-top: 20px" id="cancel" class="btn btn-success">
                Hủy bỏ
            </button>
        </div>
    </div>
</body>
<script>
    "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gBASE_URL = "http://203.171.20.210:8080/crud-api/users/";
    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    $(document).ready(function () {
        onPageLoading();
        $("#updateUser").on("click", function () {
            onBtnUpdateClick()
        })
    })
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    // Hàm xử lý sự kiện khi f5
    function onPageLoading() {
        var vUrlString = window.location.href;
        var vUrl = new URL(vUrlString);
        var vId = vUrl.searchParams.get("id")
        $.ajax({
            url: gBASE_URL + vId,
            type: "GET",
            dataType: "json",
            success: function (res) {
                loadDataToForm(res)
            },
            error: function (ajaxContext) {
                alert(ajaxContext.responseText)
            }
        })
    }
    // hàm xử lý sự kiện khi click nút Update data
    function onBtnUpdateClick() {
        var vUser = {
            id: 0,
            firstname: "",
            lastname: "",
            subject: "",
            country: "",
            customerType: "",
            registerStatus: "",
        }
        // B1 Thu thập dữ liệu
        getDataToObject(vUser)
        // B2 Kiểm tra dữ liệu
        var vValidate = isDataValidate(vUser)
        if (vValidate == true) {
            //B3 Gọi Api xử lý
            $.ajax({
                url: gBASE_URL + vUser.id,
                type: "PUT",
                contentType: "application/json;charset=UTF-8",
                data: JSON.stringify(vUser),
                //B4 hiển thị xử lý
                success: updateUser,
                error: processError,
            })

        }


    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    // Hàm điền data nhận từ Rest Api vào form
    function loadDataToForm(paramResponseObject) {
        $("#firstname").val(paramResponseObject.firstname)
        $("#lastname").val(paramResponseObject.lastname)
        $("#subject").val(paramResponseObject.subject)
        $("#country").val(paramResponseObject.country)
        $("#customerType").val(paramResponseObject.customerType)
        $("#registerStatus").val(paramResponseObject.registerStatus)
    }
    //Hầm thu thập dữ liệu từ form
    function getDataToObject(paramObject) {
        var vUrlString = window.location.href;
        var vUrl = new URL(vUrlString);
        paramObject.id = vUrl.searchParams.get("id")
        paramObject.firstname = $("#firstname").val().trim()
        paramObject.lastname = $("#lastname").val().trim()
        paramObject.subject = $("#subject").val().trim()
        paramObject.country = $("#country").val().trim()
        paramObject.customerType = $("#customerType").val().trim()
        paramObject.registerStatus = $("#registerStatus").val().trim()
    }
    // Hàm kiểm tra dữ liệu
    function isDataValidate(paramObject) {
        if (paramObject.firstname == "") {
            alert("Hãy nhập firstname")
            return false
        }
        if (paramObject.lastname == "") {
            alert("Hãy nhập lastname")
            return false
        }
        if (paramObject.subject == "") {
            alert("Hãy nhập subject")
            return false
        }
        if (paramObject.country == "") {
            alert("Hãy chọn quê quán")
            return false
        }
        if (paramObject.customerType == "") {
            alert("Hãy nhập Customer Type")
            return false
        }
        if (paramObject.registerStatus == "") {
            alert("Hãy nhập Register Status")
            return false
        }
        return true
    }
    // Hàm hiển thị khi update thành công
    function updateUser(paramResponse) {
        console.log(paramResponse)
        alert("Cập nhật dữ liệu thành công")
        window.location.href = "listUsers.html"
    }
    // Hàm hiển thị khi gặp lỗi
    function processError(paramAjaxContext) {
        console(paramAjaxContext.responseText)
        alert("Vui lòng thử lại sau")
        window.location.href = "listUsers.html"
    }
</script>

</html>